/******************************************************
** Program: Rozstawianie krolowych na szachownicy
**          metoda algorytmow z powrotami
** Autor: Marek Ha
** DataL 29.05.2006
** Wersja dla AmigaOS
******************************************************/

#include <iostream.h>
#include <proto/intuition.h>
#include <proto/utility.h>
#include <proto/muimaster.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <dos/dos.h>
#include <machine/reg.h>
#include <exec/libraries.h>
#include <exec/types.h>
#include <intuition/intuition.h>
#include <clib/alib_protos.h>
#include <libraries/mui.h>
#include <stdio.h>
#include "wstawka_asm.h"
#include <graphics/gfx.h>
#include <math.h>
#include <stdlib.h>
#include <mui/ImageButton_mcc.h>

BOOL czy_Obiecujacy (int);
void ustaw_Krolowe (int,ULONG);
void Wyczysc_szachownice();
struct Library *MUIMasterBase;
Object *Program, *Okno, *Grupa, *Suwak, *TxtButt, *Stan, *Lista;
Object *ibButton[10][10];

  ULONG n=1;
  int k=8;
  int col[19];
  int rozw=0;


void Wyczysc_szachownice()
{

 ULONG *liczba;
 liczba = new ULONG;

GetAttr (MUIA_Slider_Level, Suwak, liczba); // rozmiar szachownicy

struct MUIS_ImageButton_Image image2;

  image2.ibi_ImageType = MUIV_ImageButton_ImageType_File;
  image2.ibi_Precision = PRECISION_EXACT;
  image2.ibi_UseFriend = TRUE;
  image2.ibi_Filename  = "pole_biale2.iff";

struct MUIS_ImageButton_Image image3;

  image3.ibi_ImageType = MUIV_ImageButton_ImageType_File;
  image3.ibi_Precision = PRECISION_EXACT;
  image3.ibi_UseFriend = TRUE;
  image3.ibi_Filename  = "pole_szare2.iff";

  DoMethod (Stan, MUIM_Set, MUIA_Text_Contents, "\33cczyszczenie");


for (int d=1;d<=n;d++) // czyszczenie calej szachownicy
  {
      for (int p=1;p<=n;p++)
    {
 	  if ((p+d)%2)

					 SetAttrs (ibButton[d][p],MUIA_ImageButton_Image, &image3, TAG_END);
                else
                SetAttrs (ibButton[d][p],MUIA_ImageButton_Image, &image2, TAG_END);
   }
  }

     for (int x=1;x<=10;x++) // czyszczenie tablicy
    col[x]=x;


  DoMethod (Stan, MUIM_Set, MUIA_Text_Contents, "\33cformatowanie");

if (n == *liczba) // jesli rozmiar szachownicy sie nie zmienil
  {
  	 for (x=1; x<=n; x++)
    DoMethod(ibButton[x][x],MUIM_Set,MUIA_ShowMe,1);
  }

  else // w innym wypadku odkrywam/zakrywam dodatkowe pola
  {
   for (x=1; x<=k; x++)
   {
     DoMethod(ibButton[x][x],MUIM_Set,MUIA_ShowMe,1);

     if(x>(*liczba))

     DoMethod(ibButton[x][x],MUIM_Set,MUIA_ShowMe,0);
   }
 }

delete liczba;

}

/**********************************
** Definicja metody ustaw_Krolowe
**********************************/

void ustaw_Krolowe (int i, ULONG ktore_rozw)
{

  int j;

  if (czy_Obiecujacy(i)==TRUE)
   {
     if (i==n)
       {
         // rozstawiono wszystkie krolowe

		struct MUIS_ImageButton_Image image3;

		  image3.ibi_ImageType = MUIV_ImageButton_ImageType_File;
  		  image3.ibi_Precision = PRECISION_EXACT;
        image3.ibi_UseFriend = TRUE;
        image3.ibi_Filename  = "krolowa_szara2.iff";

      struct MUIS_ImageButton_Image image2;

        image2.ibi_ImageType = MUIV_ImageButton_ImageType_File;
        image2.ibi_Precision = PRECISION_EXACT;
        image2.ibi_UseFriend = TRUE;
        image2.ibi_Filename  = "krolowa_biala2.iff";


     DoMethod (Stan, MUIM_Set, MUIA_Text_Contents, "\33custawianie");

          for (int p=1;p<=n;p++)
           {
              if (rozw==ktore_rozw) // ktore rozwiazanie
               {
	 				 if ((p+col[p])%2)  // wyswietlenie krolowych

					 SetAttrs (ibButton[p][(col[p])],MUIA_ImageButton_Image, &image3, TAG_END);
                else
                SetAttrs (ibButton[p][(col[p])],MUIA_ImageButton_Image, &image2, TAG_END);
               }
           }
   rozw++;

       }
     else

       for (j=1; j<=n; j++)
        {
          col[i+1] = j;
          ustaw_Krolowe(i+1, ktore_rozw);
        }

  }
}

/**********************************
** Definicja metody czy_Obiecujacy
**********************************/

BOOL czy_Obiecujacy (int i)
{
  int k;
  BOOL obiecujacy;

  k = 1;
  obiecujacy = TRUE;

  while (k<i && obiecujacy)
   {
     if (col[i] == col[k] || abs (col[i]-col[k])==(i-k))
      obiecujacy = FALSE;
     k++;
   }
  return obiecujacy;
}


long Ustaw (REG(a0) struct Hook *hook, REG(a2) Object *obj, REG(a1) long *numer)
{

   DoMethod(Lista,MUIM_List_Clear); //czyszczenie listy

   Wyczysc_szachownice(); // czyszczenie szachownicy

		ULONG *wymiar;
		 wymiar = new ULONG ;

  GetAttr(MUIA_Slider_Level,Suwak,wymiar); // pobranie wymiarow szachownicy

  n=(*wymiar);

   ustaw_Krolowe(0,0);

  DoMethod (Stan, MUIM_Set, MUIA_Text_Contents, "\33cgotowe");

  char textl[64];

   for (int x=0; x<rozw; x++) // wypelnienie listy, rozwiazaniami
   {
     sprintf (textl, "%ld", x+1);
      DoMethod (Lista, MUIM_List_InsertSingle,textl, x);
   }

  rozw=0; // zerowanie ilosci rozwiazan

  delete wymiar;
  return 0;
 }


struct Hook h_Ustaw = {NULL, NULL, (HOOKFUNC)Ustaw, NULL, NULL};

long Ustaw_z_listy (REG(a0) struct Hook *hook, REG(a2) Object *obj, REG(a1) long *rozmiar)
{

	Wyczysc_szachownice();

	ULONG *rozwiazanie;
	ULONG liczba;

		rozwiazanie = new ULONG ;

	GetAttr(MUIA_List_Active,Lista,rozwiazanie);  // ktore rozwiazanie
													   	// ma zostac wyswietlone

	liczba = *rozwiazanie;

		ustaw_Krolowe(0,liczba);

		rozw=0;

	DoMethod (Stan, MUIM_Set, MUIA_Text_Contents, "\33cgotowe");


delete rozwiazanie;
 return 0;
 }

struct Hook h_Ustaw_z_listy = {NULL, NULL, (HOOKFUNC)Ustaw_z_listy,
			        NULL, NULL};

// glowna petla programu

int main (void)
{

struct MUIS_ImageButton_Image pole_szare;
  pole_szare.ibi_ImageType = MUIV_ImageButton_ImageType_File;
  pole_szare.ibi_Precision = PRECISION_EXACT;
  pole_szare.ibi_UseFriend = TRUE;
  pole_szare.ibi_Filename  = "pole_szare2.iff";

struct MUIS_ImageButton_Image pole_biale;
  pole_biale.ibi_ImageType = MUIV_ImageButton_ImageType_File;
  pole_biale.ibi_Precision = PRECISION_EXACT;
  pole_biale.ibi_UseFriend = TRUE;
  pole_biale.ibi_Filename  = "pole_biale2.iff";

  unsigned long signals;

   struct IntuitionBase *IntuitionBase=NULL;

   if (IntuitionBase = (struct IntuitionBase*)
   OpenLibrary ("intuition.library",37))

   {
    if (MUIMasterBase = OpenLibrary ("muimaster.library", 19))

     {

      if (Program = MUI_NewObject (MUIC_Application,
       MUIA_Application_Author,      (long)"Marek Ha",
       MUIA_Application_Base,        (long)"problem n-krolowych",
       MUIA_Application_Copyright,   (long)"Freeware",
       MUIA_Application_Description, (long)"problem n-krolowych",
       MUIA_Application_Title,       (long)"Szachownica",
       MUIA_Application_Window,      Okno = MUI_NewObject (MUIC_Window,
         MUIA_Window_Activate,         TRUE,
         MUIA_Window_ID,               0x4F445752,
         MUIA_Window_Title,            (long)"Problem n-krlowych -  2006 Marek Ha",
         MUIA_Window_RootObject,       Grupa = MUI_NewObject (MUIC_Group,
           MUIA_Group_Horiz,             TRUE,
           MUIA_Group_Child,             (long)MUI_NewObject (MUIC_Group,
             MUIA_Group_Columns,           2,
             MUIA_Group_Spacing,           2,

// poczatek grupy Panel (nazwa niewidoczna)

MUIA_Group_Child, MUI_NewObject (MUIC_Group,
      MUIA_Group_Horiz, FALSE,
      MUIA_Frame, MUIV_Frame_Group,
      MUIA_Background, MUII_GroupBack,
      MUIA_Group_Rows, 1,
      MUIA_Group_Spacing,           2,

// poczatek grupy Szachownica

      MUIA_Group_Child, MUI_NewObject (MUIC_Group,
      MUIA_Group_Horiz, TRUE,
      MUIA_Frame, MUIV_Frame_Group,
      MUIA_Background, MUII_GroupBack,
      MUIA_FrameTitle, (long)"Szachownica",
      MUIA_Group_Rows, 8,
      MUIA_Group_Spacing,           0,


  				Child, ibButton[1][1] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
                MUIA_HorizWeight, 0,
              End,

            Child, ibButton[1][2] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,


  				Child, ibButton[1][3] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

         	Child, ibButton[1][4] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[1][5] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[1][6] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[1][7] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

			   Child, ibButton[1][8] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

			   Child, ibButton[2][1] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

  				Child, ibButton[2][2] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,

                MUIA_CycleChain, TRUE,
              End,

         	Child, ibButton[2][3] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[2][4] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,

                MUIA_CycleChain, TRUE,
              End,

 				Child, ibButton[2][5] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

  				Child, ibButton[2][6] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

  				Child, ibButton[2][7] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

  				Child, ibButton[2][8] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

  				Child, ibButton[3][1] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,
				Child, ibButton[3][2] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,


				Child, ibButton[3][3] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,


  				Child, ibButton[3][4] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[3][5] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[3][6] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[3][7] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[3][8] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

            Child, ibButton[4][1] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,
				Child, ibButton[4][2] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,


				Child, ibButton[4][3] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,


  				Child, ibButton[4][4] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[4][5] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[4][6] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[4][7] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[4][8] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[5][1] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,
				Child, ibButton[5][2] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,


				Child, ibButton[5][3] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,


  				Child, ibButton[5][4] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[5][5] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[5][6] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

            Child, ibButton[5][7] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                 MUIA_CycleChain, TRUE,
              End,

      		Child, ibButton[5][8] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

            Child, ibButton[6][1] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,
				Child, ibButton[6][2] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,


				Child, ibButton[6][3] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,


  				Child, ibButton[6][4] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[6][5] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[6][6] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

            Child, ibButton[6][7] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

            Child, ibButton[6][8] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,
           Child, ibButton[7][1] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,
				Child, ibButton[7][2] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,


				Child, ibButton[7][3] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,


  				Child, ibButton[7][4] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[7][5] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[7][6] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

            Child, ibButton[7][7] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,

            End,

				Child, ibButton[7][8] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

            Child, ibButton[8][1] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,
				Child, ibButton[8][2] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,


				Child, ibButton[8][3] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,


  				Child, ibButton[8][4] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[8][5] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

				Child, ibButton[8][6] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,

            Child, ibButton[8][7] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_szare,
                MUIA_CycleChain, TRUE,
              End,

            Child, ibButton[8][8] = ImageButtonObject,
                MUIA_ImageButton_Image, &pole_biale,
                MUIA_CycleChain, TRUE,
              End,


    End, // koniec grupy Szachownica

  End, // koniec panelu bez nazwy

// poczatek grupy Panel (nazwa niewidoczna)

MUIA_Group_Child, MUI_NewObject (MUIC_Group,
      MUIA_Group_Horiz, FALSE,
      MUIA_Frame, MUIV_Frame_Group,
      MUIA_Background, MUII_GroupBack,
      MUIA_Group_Rows, 4,
      MUIA_Group_Spacing,           3,

// poczatek grupy Stan

  MUIA_Group_Child, MUI_NewObject (MUIC_Group,
      MUIA_Group_Horiz, FALSE,
      MUIA_Frame, MUIV_Frame_Group,
      MUIA_Background, MUII_GroupBack,
      MUIA_FrameTitle, (long)"Stan",
      MUIA_Group_Rows, 1,
      MUIA_Group_Spacing,           2,


 		   MUIA_Group_Child, Stan = MUI_NewObject (MUIC_Text,
	       MUIA_Frame, MUIV_Frame_Text,
	       MUIA_Background, MUII_TextBack,
	       TAG_END),

End, // koniec grupy stan

// poczatek grupy "Wymiar szachownicy"

MUIA_Group_Child, MUI_NewObject (MUIC_Group,
      MUIA_Group_Horiz, FALSE,
      MUIA_Frame, MUIV_Frame_Group,
      MUIA_Background, MUII_GroupBack,
      MUIA_FrameTitle, (long)"Rozmiar szachownicy",
      MUIA_Group_Rows, 1,
      MUIA_Group_Spacing, 2,


			MUIA_Group_Child, Suwak = MUI_NewObject (MUIC_Slider,
             MUIA_Slider_Horiz, TRUE,
             MUIA_Numeric_Min, 4,
             MUIA_Numeric_Max, 8,
             TAG_END),

	End, // koniec grupy Wymiar szachownicy

		   MUIA_Group_Child,  TxtButt = MUI_NewObject (MUIC_Text,
               MUIA_Frame,  MUIV_Frame_Button,
               MUIA_Background, MUII_ButtonBack,
               MUIA_Font, MUIV_Font_Button,
               MUIA_InputMode,  MUIV_InputMode_RelVerify,
               MUIA_Text_Contents,  (long)"\33cUstaw krlowe",
               TAG_END),

	// poczatek grupy "Wybierz rozwiaznie"

	MUIA_Group_Child, MUI_NewObject (MUIC_Group,
   	   MUIA_Group_Horiz, FALSE,
      	MUIA_Frame, MUIV_Frame_Group,
	      MUIA_Background, MUII_GroupBack,
	      MUIA_FrameTitle, (long)"Wybierz rozwizanie",
   	   MUIA_Group_Rows, 1,
      	MUIA_Group_Spacing, 3,

	MUIA_Group_Child, Lista = MUI_NewObject (MUIC_Listview,
   	   MUIA_Listview_List, MUI_NewObject (MUIC_List,
      	MUIA_List_ConstructHook, MUIV_List_ConstructHook_String,
       	MUIA_List_DestructHook, MUIV_List_DestructHook_String,
      	MUIA_Frame, MUIV_Frame_ReadList,
      TAG_END),
	TAG_END),

 End, // koniec grupy "Wybierz rozwiazanie"

End, // koniec grupy Panel


TAG_END),
TAG_END),
TAG_END)))

{


// ustawienie notyfikacji

  DoMethod (TxtButt, MUIM_Notify, MUIA_Pressed, FALSE, Suwak,
    2, MUIM_CallHook, &h_Ustaw);

  DoMethod (Lista, MUIM_Notify, MUIA_Listview_DoubleClick, TRUE, Suwak,
    2, MUIM_CallHook, &h_Ustaw_z_listy);

  DoMethod (Okno, MUIM_Notify, MUIA_Window_CloseRequest, MUIV_EveryTime,
   Program, 2, MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit);

  SetAttrs (Okno, MUIA_Window_Open, TRUE, TAG_END);

    while (DoMethod (Program, MUIM_Application_NewInput, &signals) !=
      MUIV_Application_ReturnID_Quit)
        {
          if (signals)
            {
              signals = Wait (signals | SIGBREAKF_CTRL_C);
              if (signals & SIGBREAKF_CTRL_C) break;
            }
        }

          SetAttrs (Okno, MUIA_Window_Open, FALSE, TAG_END);

          MUI_DisposeObject (Program);
        }

      CloseLibrary (MUIMasterBase);
     }
    CloseLibrary ((struct Library*)IntuitionBase);
   }
 return 0;
 }

